/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.lobby.command;

import de.steamwar.command.SWCommand;
import de.steamwar.linkage.Linked;
import de.steamwar.lobby.util.LobbyPlayer;
import de.steamwar.sql.SteamwarUser;
import de.steamwar.sql.UserPerm;
import org.bukkit.entity.Player;

@Linked
public class FlyCommand extends SWCommand {

    public FlyCommand() {
        super("fly");
    }

    @Register
    public void genericCommand(Player player) {
        SteamwarUser user = SteamwarUser.get(player.getUniqueId());

        if (!user.hasPerm(UserPerm.TEAM)) {
            player.sendMessage("§cUnbekannter Befehl.");
            return;
        }

        LobbyPlayer lobbyPlayer = LobbyPlayer.getLobbyPlayer(player);
        boolean newFlightState = !lobbyPlayer.isFlying();

        lobbyPlayer.setFly(newFlightState);
        player.setAllowFlight(newFlightState);
        player.setFlying(newFlightState);
        player.sendMessage("§7Du kannst jetzt " + (newFlightState ? "§afliegen§7." : "§cnicht §7mehr fliegen."));
    }
}
